#ifndef ED_STRING_INCLUDED
#define ED_STRING_INCLUDED

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>

#define _String(text)                                                          \
    ((string){.data = (uint8_t *)text, .len = sizeof(text), .owned = false})
typedef struct {
    uint8_t *data;
    size_t len;

    bool owned;
} string;

#ifdef ED_STRING_IMPLEMENTATION
bool string_eq(string a, string b) {
    if (a.len != b.len)
        return false;

    for (size_t i = 0; i < a.len; ++i) {
        if (a.data[i] != b.data[i])
            return false;
    }

    return true;
}

string string_copy(string a) {
    string new_string;

    new_string.data = malloc(a.len * sizeof(uint8_t));
    new_string.len = a.len;
    new_string.owned = true;

    memcpy(new_string.data, a.data, new_string.len * sizeof(uint8_t));

    return new_string;
}

#endif
#endif
